package de.cs.hsrm.swt.knauf.blatt7;

import java.awt.Color;
import java.awt.Graphics;

import javax.swing.JPanel;

/**Panel auf dem das Haus vom Nikolaus gezeichnet wird: Zeichnen wird aktiviert durch Aufruf
 * von "setDrawIt(true)"
 * 
 *
 */
public class Nikohaus extends JPanel
{
  /**
   * Nur damit Eclipse nicht meckert: alle Serializable Klassen bentigen eine Serialisierungsversion.
   * 
   */
  private static final long serialVersionUID = 1L;


  private  boolean drawIt = false;

  public boolean isDrawIt()
  {
    return drawIt;
  }

  public void setDrawIt(boolean drawIt)
  {
    this.drawIt = drawIt;
    
   
    //In beiden Fllen neu zeichnen - wenn "isDrawIt" = false, dann wird  ein leeres Panel gezeichnet.
    this.repaint();
  }
  
  @Override
  protected void paintComponent(Graphics g)
  {
    
    super.paintComponent(g);
    
    //Rahmen um alles - als Kennzeichnung des Zeichenbereichs (nicht relevant fr die Lsung der Aufgabe)
    g.drawRect(0,  0, this.getWidth() - 1, this.getHeight() - 1);
    
    if (this.drawIt == true)
    {
      //Wenn "drawIt" == true, dann wird gem Aufgabenstellung gezeichnet:
      
      //Hier msste die Methode "draw" eingebaut und aufgerufen werden!
      
      //TODO:
      g.setColor(Color.RED);
      g.drawString("Hier muss gezeichnet werden: Zeile 1", 10, 50);

      //Halbe Sekunde warten: geht in Java ber "Thread.sleep".
      //ACHTUNG: die gezeichneten Elemente erscheinen erst, wenn die Methode abgearbeitet ist.
      //Man muss ein "try/catch" einbauen, damit das Zeichnen klappt
      try
      {
        Thread.sleep(500);
      }
      catch (InterruptedException e)
      {
        e.printStackTrace();
      }
      
      g.setColor(Color.GREEN);
      g.drawString("Hier muss gezeichnet werden: Zeile 2", 10,100);
    }
  }
  
  

}
