package de.cs.hsrm.swt.knauf.blatt7;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;

/**Hauptfenster des Nikolaus-Haus
 * 
 */
public class NikohausFrame extends JFrame
{
  /**
   * Nur damit Eclipse nicht meckert: alle Serializable Klassen bentigen eine Serialisierungsversion.
   * 
   */
  private static final long serialVersionUID = 1L;

  private JButton buttonStartStop;
  private Nikohaus panelNikohaus;
  
  /**Main-Methode, bernimmt den Anwendungsstart.
   * 
   * @param args Kommandozeilenargumente, hier egal.
   */
  public static void main(String[] args)
  {

    NikohausFrame form = new NikohausFrame();

    form.setVisible(true);

  }
  
  /**Konstruktor, initialisiert die GUI
   * 
   */
  public NikohausFrame()
  {
    this.setDefaultCloseOperation(EXIT_ON_CLOSE);

    GridBagLayout layout = new GridBagLayout();
    this.getRootPane().setLayout(layout);

    this. buttonStartStop = new JButton();
    this.buttonStartStop.setText("Start");
    this.buttonStartStop.setToolTipText("Zeichnen starten.");
    this.buttonStartStop.setSize(150, 26);
    this.buttonStartStop.setMinimumSize(new Dimension(150, 26));
    this.buttonStartStop.addActionListener(new ActionListener()
    {

      @Override
      public void actionPerformed(ActionEvent e)
      {
        startStopZeichnen();
      }
    });
    layout.setConstraints(this.buttonStartStop, new GridBagConstraints(0, 0, 1, 1, 0, 0,
        GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(10, 10, 0, 10), 0, 0));
    this.getRootPane().add(this.buttonStartStop);
    
    
    
    this.panelNikohaus = new Nikohaus();
    layout.setConstraints(this.panelNikohaus, new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0,
        GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH, new Insets(10, 10, 10, 10), 0, 0));
    this.getRootPane().add(this.panelNikohaus);
    
    
    this.setSize(500, 500);
    this.setMinimumSize(new Dimension(500, 500));
    
    this.setTitle("Das Haus vom Nikolaus");
  }
  
  /**Button "Start/Stop" wird geklickt: Zeichnen an/abschalten und Buttontext umschalten.
   * 
   */
  private void startStopZeichnen()
  {
    boolean isDrawIt = this.panelNikohaus.isDrawIt();
    //Negieren:
    isDrawIt = !isDrawIt;
    this.panelNikohaus.setDrawIt(isDrawIt );
    
    //Buttontext anpassen:
    if (isDrawIt == true)
    {
      this.buttonStartStop.setText("Stop");
    }
    else
    {
      this.buttonStartStop.setText("Start");
    }
    
  }
}
